''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Copyright (C) 2016 NEC CORPORATION
''
'' ALL RIGHTS RESERVED BY NEC CORPORATION, THIS PROGRAM
'' MUST BE USED SOLELY FOR THE PURPOSE FOR WHICH IT WAS
'' FURNISHED BY NEC CORPORATION, NO PART OF THIS PROGRAM
'' MAY BE REPRODUCED OR DISCLOSED TO OTHERS, IN ANY FORM
'' WITHOUT THE PRIOR WRITTEN PERMISSION OF NEC CORPORATION.
'' USE OF COPYRIGHT NOTICE DOES NOT EVIDENCE PUBLICATION
'' OF THE PROGRAM
''
''            NEC CONFIDENTIAL AND PROPRIETARY
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

Private Const ESM_NOT_FOUND = "ESMPRO/ServerManager ̃CXg[񂪎擾ł܂łB"
Private Const CONFIRM_ESM_INSTALL = "ESMPRO/ServerManager CXg[Ă邩mFĉB"
Private Const FILE_NOT_FOUND = "t@C܂łB"
Private Const CONFIRM_PATCH = "pb`t@C̃XNvgƓtH_ɑ݂邩mFĉB"
Private Const FILE_WRITE_ERR = "t@C݂̏Ɏs܂B"
Private Const CONFIRM_AUTH = "tH_̏݌mFĉB"

Private Const REGISTRY_PATH86 = "HKLM\SOFTWARE\NEC\ESMSM\PathName"
Private Const REGISTRY_PATH64 = "HKLM\SOFTWARE\Wow6432Node\NEC\ESMSM\PathName"

Private Const CLASS_FILE_ESMPING_RECEIVER_THREAD = "EsmPingReceiverThread.class"
Private Const CLASS_FILE_ESMPING_COMMAND = "EsmPingCommand.class"
Private Const LIB_FILE_ESMPING = "esmPing.dll"

Private Const LIB_FILE_MWA = "MwaBm.dll"

Private Const BIN_DIR = "NVBASE\BIN\"


Main

'
' C֐
'
Sub Main()
  WScript.Echo "CW[̃XgAJn܂B"


  UpdateFile LIB_FILE_MWA, BIN_DIR

  WScript.Echo "CW[̃XgA܂B"
End Sub

'
' w肵tH_̃t@Cu
'
Sub UpdateFile(classFileName, fileDirPath)
  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  Dim esmRoot
  esmRoot = GetPath()
  Dim classDir
  classDir = objFSO.BuildPath(esmRoot, fileDirPath)
  Dim classFile
  classFile = objFSO.BuildPath(classDir, classFileName)
  Dim orgFile
  orgFile = classFile & ".org"
  Dim patchFile
  patchFile = objFSO.BuildPath(Replace(WScript.ScriptFullName, WScript.ScriptName, ""), classFileName)

  'Apply classDir, classFile, orgFile, patchFile
  Restore classDir, orgFile, classFile
End Sub

Sub DeleteFile(classFileName, fileDirPath)
  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  Dim esmRoot
  esmRoot = GetPath()
  Dim classDir
  classDir = objFSO.BuildPath(esmRoot, fileDirPath)
  Dim classFile
  classFile = objFSO.BuildPath(classDir, classFileName)
  Dim orgFile
  orgFile = classFile & ".org"
  Dim patchFile
  patchFile = objFSO.BuildPath(Replace(WScript.ScriptFullName, WScript.ScriptName, ""), classFileName)

  DeletePatchFile classFile
End Sub

'
' {pb`Kp
'
Sub Apply(classDir, classFile, orgFile, patchFile)
  
  SaveOldFile classFile, orgFile, classDir
  CopyPatchFile patchFile, classDir
  
End Sub

'
' {pb`̓KpɁȀԂɖ߂
'
Sub Restore(classDir, orgFile, classFile)

  DeletePatchFile classFile
  RestoreOldFile classFile, orgFile, classDir

End Sub

'
' ESMPRO/ServerManager Ver.6 ̃CXg[pX擾
'
Function GetPath()
  ' A[LeN`̔
  Dim shell
  Set shell = CreateObject("WScript.Shell")
  Dim strOSArchitecture
  strOSArchitecture = shell.ExpandEnvironmentStrings("%PROCESSOR_ARCHITECTURE%")
  Dim regPath
  If LCase(strOSArchitecture) = "x86" Then
    regPath = REGISTRY_PATH86
  Else
    regPath = REGISTRY_PATH64
  End If

  On Error Resume Next
  Dim esmsmPath
  esmsmPath = shell.RegRead(regPath)
  If Err.Number <> 0 Then
    WScript.Echo ESM_NOT_FOUND & vbCrLf & CONFIRM_ESM_INSTALL
    WScript.Quit Err.Number
  End If
  On Error Goto 0

  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  GetPath = objFSO.GetParentFolderName(esmsmPath)
End Function

'
' pb`KpÕt@Cʖŕۑ
'
Sub SaveOldFile(classFile, orgFile, classDir)
  On Error Resume Next
  MoveFile classFile, orgFile
  If Err.Number = 53 Then ' file not found
    WScript.Echo "Cs" & FILE_NOT_FOUND & vbCrLf & classFile & vbCrLf & CONFIRM_ESM_INSTALL
    WScript.Quit Err.Number
  ElseIf Err.Number = 70 Then ' Failed to write
    WScript.Echo FILE_WRITE_ERR & vbCrLf & classDir & " " & CONFIRM_AUTH
    WScript.Quit Err.Number
  ElseIf Err.Number <> 0 Then
    WScript.Echo "Error(" & Err.Number & ") :" & Err.Description
    WScript.Quit Err.Number
  End If
  On Error Goto 0
End sub

'
' pb`KpÕt@Cɖ߂
'
Sub RestoreOldFile(classFile, orgFile, classDir)
  On Error Resume Next
  MoveFile orgFile, classFile
  If Err.Number = 53 Then ' file not found
    WScript.Echo FILE_NOT_FOUND & vbCrLf & orgFile
    WScript.Quit Err.Number
  ElseIf Err.Number = 70 Then ' Failed to write
    WScript.Echo FILE_WRITE_ERR & vbCrLf & classDir & " " & CONFIRM_AUTH
    WScript.Quit Err.Number
  ElseIf Err.Number <> 0 Then
    WScript.Echo "Error(" & Err.Number & ") :" & Err.Description
    WScript.Quit Err.Number
  End If
  On Error Goto 0
End sub

'
' pb`Rs[
'
Sub CopyPatchFile(patchFile, classDir)
  On Error Resume Next
  CopyFile patchFile, classDir
  If Err.Number = 53 Then ' file not found
    WScript.Echo FILE_NOT_FOUND & vbCrLf & patchFile & vbCrLf & CONFIRM_PATCH
    WScript.Quit Err.Number
  ElseIf Err.Number = 70 Then ' Failed to write
    WScript.Echo FILE_WRITE_ERR & vbCrLf & classDir & " " & CONFIRM_AUTH
    WScript.Quit Err.Number
  ElseIf Err.Number <> 0 Then
    WScript.Echo "Error(" & Err.Number & ") :" & Err.Description
    WScript.Quit Err.Number
  End If
  On Error Goto 0
End Sub

'
' pb`t@C폜
'
Sub DeletePatchFile(strFile)
  On Error Resume Next
  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  If Err.Number = 0 Then
    objFSO.DeleteFile strFile, True
    If Err.Number = 0 Or Err.Number = 53 Then
'      Removed old file successfully or it has already been removed.
    Else
      WScript.Echo "Error(" & Err.Number & ") :" & Err.Description
      WScript.Quit Err.Number
    End If
  Else
    WScript.Echo "Error(" & Err.Number & ") :" & Err.Description
    WScript.Quit Err.Number
  End If
  On Error Goto 0
end Sub

'
' t@Cړ
'
Sub MoveFile(strSrcFile, strDestFile)
  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  objFSO.MoveFile strSrcFile, strDestFile
  Set objFSO = Nothing
End Sub

'
' t@CRs[
'
Sub CopyFile(strSrcFile, strDestDir)
  Dim objFSO
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  objFSO.CopyFile strSrcFile, strDestDir, True
end Sub
